libretools - Bug #807

[librechroot] Support using proot to call QEMU for foreign architectures
2015-09-22 06:19 AM - Anonymous

Status: not-a-bug % Done: 0%
Priority: feature

Assignee: lukeshu

Category: ARM on x86

Description

Merge PRoot project to libretools for easy compiling multiple architecture

http://proot.me/

PRoot description:

PRoot is a user-space implementation of chroot, mount --bind, and binfmt_misc. This means that users don't need any privileges or
setup to do things like using an arbitrary directory as the new root filesystem, making files accessible somewhere else in the
filesystem hierarchy, or executing programs built for another CPU architecture transparently through QEMU user-mode. Also,
developers can use PRoot as a generic GNU/Linux process instrumentation engine thanks to its extension mechanism, see CARE
for an example. Technically PRoot relies on ptrace, an unprivileged system-call available in every Linux kernel.

Example:

1. mount -o rbind /dev <chroot-dir>/dev

2. mount -o bind /sys <chroot-dir>/sys

3. mount -o bind /tmp <chroot-dir>/tmp

4. mount -t proc none <chroot-dir>/proc

5. proot -0 -q /usr/bin/gemu-arm -r <chroot-dir>

Note: "-0" means root user access.

Related issues:

Related to libretools - Bug #987: [librechroot] Support using binfmt_misc to ... fixed 2016-04-15
Blocks libretools - Porting #787: [librechroot] Support ARM chroots on x86 vi... fixed 2015-08-19
History

#1 - 2015-09-23 01:47 AM - Anonymous

- Related to Bug #790: Add support QEMU in chroot on nonnative architecture to build other systems without need to use cross-compiling added

#2 - 2015-09-23 01:48 AM - Anonymous
- Related to Porting #787: [librechroot] Support ARM chroots on x86 via QEMU added

#3 - 2015-09-23 01:49 AM - Anonymous

- Related to Bug #791: Support cross-compiling for other architectures without need extra dependencies added

#4 - 2015-09-23 01:49 AM - Anonymous
- Related to Bug #808: Package [dbscripts] similarly to libretools for easy use in Parabola server added

#5 - 2015-09-23 06:00 AM - Anonymous
https://wiki.parabola.nu/How_to_build ARMv7_packages_from_a_chroot_with_PRoot_for Parabola_ ARM

#6 - 2016-04-15 11:16 PM - lukeshu

- Subject changed from Merge PRoot project to libretools for easy compiling multiple architecture to [librechroot] Use proot for calling QEMU for foreign
architectures

#7 - 2016-04-15 11:19 PM - lukeshu

- Subject changed from [librechroot] Use proot for calling QEMU for foreign architectures to [librechroot] Support using proot to call QEMU for foreign
architectures
#8 - 2016-04-15 11:31 PM - lukeshu

- Related to deleted (Bug #790: Add support QEMU in chroot on nonnative architecture to build other systems without need to use cross-compiling)

#9 - 2016-04-15 11:31 PM - lukeshu

- Related to deleted (Bug #791: Support cross-compiling for other architectures without need extra dependencies)

#10 - 2016-04-15 11:32 PM - lukeshu
- Related to deleted (Bug #808: Package [dbscripts] similarly to libretools for easy use in Parabola server)

#11 - 2016-04-15 11:32 PM - lukeshu
- Target version set to Basic ARM support

- Category set to ARM on x86

#12 - 2016-04-15 11:51 PM - lukeshu
- Related to Bug #987: [librechroot] Support using binfmt_misc to call QEMU for foreign architectures added

#13 - 2016-04-15 11:52 PM - lukeshu
- Related to deleted (Porting #787: [librechroot] Support ARM chroots on x86 via QEMU)

#14 - 2016-04-15 11:52 PM - lukeshu
- Blocks Porting #787: [librechroot] Support ARM chroots on x86 via QEMU added

#15 - 2016-04-16 02:33 AM - lukeshu
proot whigs out when the child process does certain things with unshare.

| think what's going on is that the child unshares, then forks a new (ARM) process, then proot directly calls gemu, so proot+gemu don't know about
the new namespace.

| think this blocks using proot with systemd-nspawn.
There's ~0% chance that I'm switching libretools away from systemd-nspawn (or a derivative).

So, | guess I'm waiting for coadde’s build of a static gemu, so | tackle #987 instead.

#16 - 2016-05-18 03:21 PM - Anonymous

- Status changed from open to not-a-bug

Don't needed since we are using gemu-static for it.
